
  { ExtraHelp v1.00 - Jon Webb, july 7th 1996                       }
  { Freeware; please report bugs, bug fixes, comments, enhancements }
  { etc. to j.webb@marketresponse.nl                                }

  { Neither the author nor his employer can be held responsible for }
  { any damage caused by the use of this utility                    }

  { This unit is used to load & save settings to the INI file       }

unit Extraini;

interface

uses classes;

procedure ReadIniFile(var HdxFile: String; SearchPathList, HelpFileList: TStringList);
procedure WriteIniFile(HdxFile: String; SearchPathList, HelpFileList: TStringList);

implementation

uses WinProcs, SysUtils;

{Loads settings from INI file}

procedure ReadIniFile(var HdxFile: String; SearchPathList, HelpFileList: TStringList);
  var s,key: string;
      i: integer;
begin

  {HDX file location}

  HDXFile[0] := char(GetPrivateProfileString('Jons.ExtraHelp',
                'HDXFile', '', @HDXFile[1], sizeOf(HDXFile)-1, 'DELPHI.INI'));

  {Additional search paths}

  i := 0;
  s := 'x';
  while s <> '' do
  begin
    key := 'Search'+IntToStr(i)+#0;
    s[0] := char(GetPrivateProfileString('Jons.ExtraHelp',
                  @key[1], '', @s[1], sizeOf(s)-1, 'DELPHI.INI'));
    if s <> '' then
      SearchPathList.Add(s);
    inc(i);
  end;

  {Additional help files}

  i := 0;
  s := 'x';
  while s <> '' do
  begin
    key := 'Help'+IntToStr(i)+#0;
    s[0] := char(GetPrivateProfileString('Jons.ExtraHelp',
                  @key[1], '', @s[1], sizeOf(s)-1, 'DELPHI.INI'));
    if s <> '' then
      HelpFileList.Add(s);
    inc(i);
  end;
end;

{Save settings to INI file}

procedure WriteIniFile(HdxFile: String; SearchPathList, HelpFileList: TStringList);
  var s,key: string;
      i: integer;
begin

  {Erase existing section first}

  WritePrivateProfileString('Jons.ExtraHelp', nil, nil, 'DELPHI.INI');

  {HDX file location}

  HdxFile := HdxFile + #0;
  WritePrivateProfileString('Jons.ExtraHelp', 'HDXFile', @HdxFile[1], 'DELPHI.INI');

  {Additional search paths}

  for i := 0 to SearchPathList.Count-1 do
  begin
    key := 'Search'+IntToStr(i)+#0;
    s := SearchPathList[i]+#0;
    WritePrivateProfileString('Jons.ExtraHelp', @key[1], @s[1], 'DELPHI.INI');
  end;

  {Additional Help files}

  for i := 0 to HelpFileList.Count-1 do
  begin
    key := 'Help'+IntToStr(i)+#0;
    s := HelpFileList[i]+#0;
    WritePrivateProfileString('Jons.ExtraHelp', @key[1], @s[1], 'DELPHI.INI');
  end;

  {Flush INI file}

  WritePrivateProfileString(nil, nil, nil, 'DELPHI.INI');

end;

end.
